#ifndef SWR_ADJACENCYMATRIX_HPP_INCLUDED
#define SWR_ADJACENCYMATRIX_HPP_INCLUDED


#include<vector>
#include<cstdint>
#include<cstddef>
 



namespace swr{


class
AdjacencyMatrix
{
  size_t   size;
  size_t  count;

  std::vector<uint8_t>  buffer;

  const uint8_t*  get_pointer(int  x, int  y) const;

public:
  AdjacencyMatrix();


  AdjacencyMatrix&  operator=(const AdjacencyMatrix&  rhs);

  void  clear();

  void  resize(int  size);

  size_t   get_size() const;
  size_t  get_count() const;

  uint8_t  get_value(int  x, int  y            ) const;
  bool     set_value(int  x, int  y, uint8_t  v)      ;

  void  print() const;

  static void  print_index_table();

};


}


#endif




