#include"swr_line.hpp"
#include"swr_linecontext.hpp"




namespace swr{




void
Line::
render(const Screen&  scr) const
{
  LineContext  ctx(a,b);

    for(;;)
    {
      auto  x = ctx.get_x();
      auto  y = ctx.get_y();
      auto  z = ctx.get_z();
  
        if((z <                 0) &&
           (x >=   scr.get_left()) &&
           (y <=    scr.get_top()) &&
           (x <=  scr.get_right()) &&
           (y >= scr.get_bottom()))
        {
          auto&  e = scr.get_element(scr.get_right()+x,
                                       scr.get_top()+y);

            if(e.z < z)
            {
              e.z     =     z;
              e.color = color;
            }
        }


        if(!ctx.step())
        {
          break;
        }
    }
}


void
Line::
print() const
{
  a.print();
  b.print();
}




}




