#ifndef SWR_LINECONTEXT_HPP_INCLUDED
#define SWR_LINECONTEXT_HPP_INCLUDED


#include"swr_point.hpp"


namespace swr{


class
LineContext
{
  Point  point0;
  Point  point1;

  int  count;

  struct Element{
    int          dist;
    int         value;
    int    add_amount;
    int  shift_amount;

  }  x, y, z;


public:
  LineContext(const Point&  pt0=Point(), const Point&  pt1=Point());

  void  reset(const Point&  pt0, const Point&  pt1);

  bool  step();

  int  get_count() const;

  int  get_x() const;
  int  get_y() const;
  int  get_z() const;

  Point  get_point() const;

  void  print(const char*  prefix=nullptr, const char*  suffix=nullptr) const;

  const Element&  get_x_element() const{return x;}
  const Element&  get_y_element() const{return y;}
  const Element&  get_z_element() const{return z;}

};


}


#endif




