#ifndef SWR_MINIVECTOR_HPP_INCLUDED
#define SWR_MINIVECTOR_HPP_INCLUDED



namespace swr{


class
MiniVector
{
  unsigned char  value;

  static constexpr int  to_element(int  n)
  {
    return((n < 0)? 1:
           (n > 0)? 3:2);
  }

  static constexpr int  to_int(int  n)
  {
    return((n == 3)? 1:
           (n == 2)? 0:-1);
  }

public:
  constexpr MiniVector(int  x=0, int  y=0, int  z=0):
  value((to_element(z)<<4)|
        (to_element(y)<<2)|
        (to_element(x)   ))
  {
  }


  constexpr int  get_x() const{return to_int((value   )&3);}
  constexpr int  get_y() const{return to_int((value>>2)&3);}
  constexpr int  get_z() const{return to_int((value>>4)&3);}

};


}


#endif




