#ifndef SWR_OBJECT_HPP_INCLUDED
#define SWR_OBJECT_HPP_INCLUDED


#include"swr_color.hpp"
#include"swr_polygon.hpp"
#include"swr_sincos.hpp"
#include"swr_line.hpp"
#include"swr_screen.hpp"
#include"swr_vector.hpp"
#include<vector>
#include<list>
#include<string>




namespace swr{


struct
Object: public RotationParameter
{
  std::string  name;

  std::list<Line>        lines;
  std::list<Polygon>  polygons;

  Object*  parent;

  std::list<Object>  children;

  Object();
  Object(Object&&  rhs);


  void  clear();

  Object&  operator=(Object&&  rhs);

  Object&  make_child();

  using Ro = RotationParameter;

  Object  transform(const Ro*  parent_ro, const Ro*  view_ro, const Vector*  light) const;

  void  push_line(   const Color&  color, const Point&  a, const Point&  b                 );
  void  push_polygon(const Color&  color, const Point&  a, const Point&  b, const Point&  c);

  void  render(Screen&  scr) const;

};


} 



#endif




