#ifndef SWR_POINT_HPP_INCLUDED
#define SWR_POINT_HPP_INCLUDED


#ifndef report
#define report  printf("[report in %s] %s %d\n",__FILE__,__func__,__LINE__)
#endif


namespace swr{


struct
Point
{
  int  x;
  int  y;
  int  z;

  constexpr Point(int  x_=0, int  y_=0, int  z_=0):
  x(x_), y(y_), z(z_)
  {
  }


  void  reset(int  x_=0, int  y_=0, int  z_=0);

  Point  operator+(const Point&  rhs) const;
  Point  operator-(const Point&  rhs) const;

  Point&  operator =(const Point&  rhs);
  Point&  operator+=(const Point&  rhs);
  Point&  operator-=(const Point&  rhs);

  bool  operator==(const Point&  rhs) const;
  bool  operator< (const Point&  rhs) const;

  void  print() const;

};


}




#endif




