#include"swr_polygon.hpp"
#include"swr_linecontext.hpp"
#include"swr_line.hpp"
#include<cstdio>




namespace swr{




void
Polygon::
sort()
{
  const Point  a = a_point;
  const Point  b = b_point;
  const Point  c = c_point;

    if(a.y > b.y)
    {
        if(a.y > c.y)
        {
            if(b.y > c.y){}
          else
            {
              b_point = c;
              c_point = b;
            }
        }

      else
        {
          a_point = c;
          b_point = a;
          c_point = b;
        }
    }

  else
    if(b.y > c.y)
    {
        if(a.y > c.y)
        {
          a_point = b;
          b_point = a;
        }

      else
        {
          a_point = b;
          b_point = c;
          c_point = a;
        }
    }

  else
    {
      a_point = c;
      c_point = a;
    }
}


Vector
Polygon::
get_vector() const
{
  Vector  v0(a_point,b_point);
  Vector  v1(b_point,c_point);

  auto  v = Vector::cross_product(v0,v1);

  return v;
}


void
Polygon::
print() const
{
  a_point.print();
  b_point.print();
  c_point.print();
}




namespace{
bool
advance(LineContext&  ctx, int  y)
{
    for(;;)
    {
        if(ctx.get_y() == y)
        {
          return true;
        }


        if(!ctx.step())
        {
          break;
        }
    }


  return false;
}
}


void
Polygon::
render(Screen&  scr) const
{
  const Point&  highest = a_point;
  const Point&   middle = b_point;
  const Point&   lowest = c_point;

  LineContext  ctx0(lowest,highest);
  LineContext  ctx1(lowest,middle);

    for(int  y = lowest.y;  y < middle.y;  ++y)
    {
      auto  res0 = advance(ctx0,y);
      auto  res1 = advance(ctx1,y);

        if(!res0 ||
           !res1)
        {
          break;
        }


      Line(color,ctx0.get_point(),
                 ctx1.get_point()).render(scr);
    }


  ctx1.reset(middle,highest);

    for(int  y = middle.y;  y <= highest.y;  ++y)
    {
      auto  res0 = advance(ctx0,y);
      auto  res1 = advance(ctx1,y);

        if(!res0 ||
           !res1)
        {
          break;
        }


      Line(color,ctx0.get_point(),
                 ctx1.get_point()).render(scr);
    }
}




}




