#ifndef SWR_POLYGON_HPP_INCLUDED
#define SWR_POLYGON_HPP_INCLUDED


#include"swr_point.hpp"
#include"swr_color.hpp"
#include"swr_vector.hpp"
#include"swr_sincos.hpp"
#include"swr_screen.hpp"
#include<cstdint>




namespace swr{




struct
Polygon
{
  Color  color;

  Point  a_point;
  Point  b_point;
  Point  c_point;

  Polygon(){}

  constexpr Polygon(const Color&  color_, const Point&  a, const Point&  b, const Point&  c):
  color(color_),
  a_point(a),
  b_point(b),
  c_point(c){}


  void  sort();

  Vector  get_vector() const;

  void  render(Screen&  scr) const;

  void  print() const;

};




}



#endif




