#include"swr_screen.hpp"
#include<cstring>
#include<cstdlib>
#include<limits>




namespace swr{




Screen::
Screen():
elements(nullptr),
width(0),
height(0)
{
}


Screen::
Screen(Screen&&  rhs):
width(rhs.width),
height(rhs.height),
top(rhs.top),
left(rhs.left),
right(rhs.right),
bottom(rhs.bottom),
elements(rhs.elements)
{
  rhs.elements = nullptr;
}


Screen::
Screen(const Screen&  rhs):
elements(nullptr),
width(0),
height(0)
{
  resize(rhs.width,rhs.height);
}


Screen::
~Screen()
{
  free(elements);
}




void
Screen::
clear(uint8_t  r, uint8_t  g, uint8_t  b)
{
  int  n = width*height;

  auto  p = elements;

    while(n--)
    {
      auto&  e = *p++;

      e.color.r = r;
      e.color.g = g;
      e.color.b = b;
      e.color.a = 255;

      e.z = std::numeric_limits<int>::min();
    }
}


int  Screen::get_width( ) const{return width;}
int  Screen::get_height() const{return height;}
int  Screen::get_top(   ) const{return top;}
int  Screen::get_left(  ) const{return left;}
int  Screen::get_right( ) const{return right;}
int  Screen::get_bottom() const{return bottom;}


void
Screen::
resize(int  w, int  h)
{
    if((w*h) > (width*height))
    {
      free(elements)                                       ;
           elements = (Element*)malloc(sizeof(Element)*w*h);
    }


  width  = w;
  height = h;

    left = -(w/2);
     top =  (h/2);
   right =  (w/2);
  bottom = -(h/2);

  clear();
}


Screen::Element&
Screen::
get_element(int  x, int  y) const
{
  return elements[(width*y)+x];
}




}




