#ifndef SWR_SCREEN_HPP_INCLUDED
#define SWR_SCREEN_HPP_INCLUDED


#include"swr_color.hpp"
#include<cstdint>




namespace swr{


class
Screen
{
public:
  struct Element{
    Color  color;

    int  z;
  };

private:
  int   width;
  int  height;

  int     top;
  int  bottom;
  int    left;
  int   right;

  Element*  elements;

public:
   Screen(                   );
   Screen(      Screen&&  rhs);
   Screen(const Screen&   rhs);
  ~Screen(                   );

  void  clear(uint8_t  r=0, uint8_t  g=0, uint8_t  b=0);

  void  resize(int  w, int  h);

  int   get_width() const;
  int  get_height() const;
  int     get_top() const;
  int    get_left() const;
  int   get_right() const;
  int  get_bottom() const;

  Element&  get_element(int  x, int  y) const;

};


} 



#endif




