#ifndef SWR_SINCOS_HPP_INCLUDED
#define SWR_SINCOS_HPP_INCLUDED


#include"swr_point.hpp"


namespace swr{


void  get_sincos(int  degree, int&  sin_value, int&  cos_value);


constexpr double  pi = 3.141592653589793;


constexpr
int
to_degree(double  radian)
{
  return radian*180.0/pi;
}




struct
RotationParameter
{
  Point  center;

  int  x_degree;
  int  y_degree;
  int  z_degree;

  constexpr RotationParameter(const Point&  pt=Point(), int  x=0, int  y=0, int  z=0):
  center(pt),
  x_degree(x),
  y_degree(y),
  z_degree(z){}

  void  rotate_x(Point&  pt) const;
  void  rotate_y(Point&  pt) const;
  void  rotate_z(Point&  pt) const;

  void  rotate(Point&  pt) const;

};


}




#endif




