#ifndef SWR_VECTOR_HPP_INCLUDED
#define SWR_VECTOR_HPP_INCLUDED


#include"swr_point.hpp"


namespace swr{


struct
Vector
{
  using Element = double;

  Element  x;
  Element  y;
  Element  z;

  constexpr Vector(Element  x_=0, Element  y_=0, Element  z_=0):
  x(x_), y(y_), z(z_)
  {
  }


  constexpr Vector(const Point&  pt0, const Point&  pt1):
  x(pt1.x-pt0.x),
  y(pt1.y-pt0.y),
  z(pt1.z-pt0.z)
  {
  }


  void  reset(Element  x_=0, Element  y_=0, Element  z_=0);

  void  reset(const Point&  pt0, const Point&  pt1);

  Vector  operator+(const Vector&  rhs) const;
  Vector  operator-(const Vector&  rhs) const;

  Vector&  operator+=(const Vector&  rhs);
  Vector&  operator-=(const Vector&  rhs);

  static Vector  cross_product(const Vector&  a, const Vector&  b);
  static Element      dot_product(const Vector&  a, const Vector&  b);


  void  normalize();

  void  print() const;

};


}




#endif




