#include"swr_vertex.hpp"
#include<cstdio>




namespace swr{




Vertex::
Vertex(Point*  p, uint32_t  i):
point(p),
index(i),
count(1)
{}




Vertex::
operator bool() const
{
  return point;
}


Point*  Vertex::operator->() const{return point;}
Point*  Vertex::get_point()  const{return point;}


void
Vertex::
reset(Point*  p, uint32_t  i)
{
  point = p;
  index = i;
  count = 1;

  paired_index_list.clear();
}


void  Vertex::increase_count(){++count;}
void  Vertex::decrease_count(){--count;}

uint32_t  Vertex::get_count() const{return count;}
uint32_t  Vertex::get_index() const{return index;}


const std::list<uint32_t>&
Vertex::
get_paired_index_list() const
{
  return paired_index_list;
}


void
Vertex::
append_paired_index(uint32_t  i)
{
  paired_index_list.emplace_front(i);
}


void
Vertex::
remove_paired_index(uint32_t  i)
{
    if(!count)
    {
      return;
    }


  auto   it = paired_index_list.begin();
  auto  end = paired_index_list.end();

    while(it != end)
    {
        if(*it == i)
        {
          paired_index_list.erase(it);
          break;
        }


      ++it;
    }
}


void
Vertex::
print() const
{
  printf("{");

    for(auto  i: paired_index_list)
    {
      printf("%3d,",i);
    }


  printf("}");
}


}




