#ifndef SWR_VERTEX_HPP_INCLUDED
#define SWR_VERTEX_HPP_INCLUDED


#include"swr_point.hpp"
#include<cstdint>
#include<list>




namespace swr{


class
Vertex
{
  Point*  point;

  uint32_t  index;
  uint32_t  count;

  std::list<uint32_t>  paired_index_list;

public:
  Vertex(Point*  p=nullptr, uint32_t  i=0);


  operator bool() const;

  Point*  operator->() const;

  Point*  get_point() const;

  void  reset(Point*  p=nullptr, uint32_t  i=0);

  void  increase_count();
  void  decrease_count();

  uint32_t  get_count() const;
  uint32_t  get_index() const;

  const std::list<uint32_t>&  get_paired_index_list() const;

  void  append_paired_index(uint32_t  i);
  void  remove_paired_index(uint32_t  i);

  void  print() const;

};



}



#endif




